import { world, system, BlockPermutation, GameMode } from "@minecraft/server";
import { potableItems } from "../../ntk_listing.js";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:mb_potted_plants_on_player_interact", {
    onPlayerInteract: eventData => {
      const player = eventData.player;
      const block = eventData.block;
      const blockLocation = block.location;
      const playerEquippable = player.getComponent("equippable");
      const itemUsed = playerEquippable.getEquipment("Mainhand");
      
      if (itemUsed === undefined || !potableItems.includes(itemUsed.typeId)) {
        if (block.permutation.matches("nicothekid:potted_blooming_corrupted_oak_sapling")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:blooming_corrupted_oak_sapling 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_corrupted_grass")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:corrupted_grass 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_corrupted_oak_sapling")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:corrupted_oak_sapling 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_hanging_moss")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:hanging_moss 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_moss_sprouts")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:tall_moss_sprouts 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_mossy_willow_sapling")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:mossy_willow_sapling 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_overgrown_jungle_sapling")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:overgrown_jungle_sapling 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
      }
      else return;
    }
  });
});
