import { world, system, BlockPermutation, ItemStack, GameMode } from "@minecraft/server";
import { spawnItem } from "../../ntk_functions.js";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:tall_moss_sprouts_on_player_destroy", {
    onPlayerDestroy: eventData => {
      const player = eventData.player;
      const destroyedBlock = eventData.destroyedBlockPermutation;
      const block = eventData.block;
      const blockLocation = block.location;
      const playerEquippable = player.getComponent("equippable");
      const itemUsed = playerEquippable.getEquipment("Mainhand");
      let randomChance = Math.random() * 100.0;
      
      if (player.matches({ gameMode: GameMode.creative })) return;
      if (destroyedBlock.type.id === "nicothekid:tall_moss_sprouts") {
        if (itemUsed === undefined) {
          if (randomChance <= 5.0) {
            spawnItem(block, "nicothekid:short_moss_sprouts", 1);
            return;
          }
          else return;
        }
        else {
          if (itemUsed.typeId === "minecraft:shears") {
            spawnItem(block, "nicothekid:tall_moss_sprouts", 1);
            return;
          }
          else {
            const itemEnchantable = itemUsed.getComponent("enchantable");
            if (itemEnchantable) {
              const silkTouchEnchanted = itemEnchantable.getEnchantment("silk_touch");
              if (silkTouchEnchanted) return;
              const fortuneEnchanted = itemUsed.getComponent("enchantable").getEnchantment("fortune");
              if (itemUsed.getComponent("enchantable").hasEnchantment("fortune")) {
                if (fortuneEnchanted.level == 1) {
                  if (randomChance <= 8.0) {
                    spawnItem(block, "nicothekid:short_moss_sprouts", 1);
                    return;
                  }
                  else return;
                }
                if (fortuneEnchanted.level == 2) {
                  if (randomChance <= 10.0) {
                    spawnItem(block, "nicothekid:short_moss_sprouts", 1);
                    return;
                  }
                  else return;
                }
                if (fortuneEnchanted.level == 3) {
                  if (randomChance <= 15.0) {
                    spawnItem(block, "nicothekid:short_moss_sprouts", 1);
                    return;
                  }
                  else return;
                }
              }
              else {
                if (randomChance <= 10.0) {
                  spawnItem(block, "nicothekid:short_moss_sprouts", 1);
                  return;
                }
                else return;
              }
            }
            else {
              if (randomChance <= 10.0) {
                spawnItem(block, "nicothekid:short_moss_sprouts", 1);
                return;
              }
              else return;
            }
          }
        }
      }
      else return;
    }
  });
})