import { world, system, BlockPermutation, Dimension, GameMode } from "@minecraft/server";
import { decreaseItemStack } from "../../ntk_functions.js";
import { interactableBlocks, customSlab, nceCustomSlab } from "../../ntk_listing.js";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:nce_double_slab", {
    onPlayerInteract: eventData => {
      const player = eventData.player;
      const block = eventData.block;
      const blockFacing = eventData.face;
      const blockLocation = block.location;
      const playerEquippable = player.getComponent("equippable");
      const itemUsed = playerEquippable.getEquipment("Mainhand");
      
      if (itemUsed === undefined || blockFacing === "South" || blockFacing === "East" || blockFacing === "North" || blockFacing === "West") return;
      if (nceCustomSlab.includes(itemUsed.typeId) && nceCustomSlab.includes(block.typeId)) {
        if (itemUsed.typeId === "nicothekid:limestone_brick_slab") {
          if (block.permutation.matches("nicothekid:limestone_brick_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("nicothekid:limestone_brick_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.dimension.playSound("use.stone", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("nicothekid:limestone_brick_double_slab"));
            return;
          }
        }
        if (itemUsed.typeId === "nicothekid:limestone_slab") {
          if (block.permutation.matches("nicothekid:limestone_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("nicothekid:limestone_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.dimension.playSound("use.stone", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("nicothekid:limestone_double_slab"));
            return;
          }
        }
        if (itemUsed.typeId === "nicothekid:marble_brick_slab") {
          if (block.permutation.matches("nicothekid:marble_brick_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("nicothekid:marble_brick_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.dimension.playSound("place.calcite", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("nicothekid:marble_brick_double_slab"));
            return;
          }
        }
        if (itemUsed.typeId === "nicothekid:marble_slab") {
          if (block.permutation.matches("nicothekid:marble_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("nicothekid:marble_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.dimension.playSound("place.calcite", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("nicothekid:marble_double_slab"));
            return;
          }
        }
        if (itemUsed.typeId === "nicothekid:mosshroom_slab") {
          if (block.permutation.matches("nicothekid:mosshroom_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("nicothekid:mosshroom_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.dimension.playSound("step.nether_wood", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("nicothekid:mosshroom_double_slab"));
            return;
          }
        }
        if (itemUsed.typeId === "nicothekid:polished_limestone_slab") {
          if (block.permutation.matches("nicothekid:polished_limestone_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("nicothekid:polished_limestone_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.dimension.playSound("use.stone", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("nicothekid:polished_limestone_double_slab"));
            return;
          }
        }
        if (itemUsed.typeId === "nicothekid:polished_marble_slab") {
          if (block.permutation.matches("nicothekid:polished_marble_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("nicothekid:polished_marble_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.dimension.playSound("use.calcite", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("nicothekid:polished_marble_double_slab"));
            return;
          }
        }
        if (itemUsed.typeId === "nicothekid:polished_soul_stone_slab") {
          if (block.permutation.matches("nicothekid:polished_soul_stone_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("nicothekid:polished_soul_stone_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.dimension.playSound("use.stone", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("nicothekid:polished_soul_stone_double_slab"));
            return;
          }
        }
        if (itemUsed.typeId === "nicothekid:rose_quartz_slab") {
          if (block.permutation.matches("nicothekid:rose_quartz_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("nicothekid:rose_quartz_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.dimension.playSound("use.stone", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("nicothekid:rose_quartz_double_slab"));
            return;
          }
        }
        if (itemUsed.typeId === "nicothekid:smooth_rose_quartz_slab") {
          if (block.permutation.matches("nicothekid:smooth_rose_quartz_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("nicothekid:smooth_rose_quartz_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.dimension.playSound("use.stone", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("nicothekid:smooth_rose_quartz_double_slab"));
            return;
          }
        }
        if (itemUsed.typeId === "nicothekid:soul_stone_brick_slab") {
          if (block.permutation.matches("nicothekid:soul_stone_brick_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("nicothekid:soul_stone_brick_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.dimension.playSound("use.stone", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_brick_double_slab"));
            return;
          }
        }
        if (itemUsed.typeId === "nicothekid:soul_stone_slab") {
          if (block.permutation.matches("nicothekid:soul_stone_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("nicothekid:soul_stone_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.dimension.playSound("use.stone", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_double_slab"));
            return;
          }
        }
      }
      else return;
    }
  });
});
world.beforeEvents.itemUseOn.subscribe(eventData => {
  const player = eventData.source;
  const itemUsed = eventData.itemStack;
  const block = eventData.block;
  const blockFacing = eventData.blockFace;
  const blockLocation = block.location;
  const playerEquippable = player.getComponent("equippable");
  
  if (itemUsed === undefined || !playerEquippable) return;
  if (interactableBlocks.includes(block.typeId) && !player.isSneaking || block.hasTag("nicothekid:interactable_block") && !player.isSneaking) return;
  if (customSlab.includes(itemUsed.typeId)) {
    const blockAbove = block.above(1);
    const blockBelow = block.below(1);
    const blockSouth = block.south(1);
    const blockEast = block.east(1);
    const blockNorth = block.north(1);
    const blockWest = block.west(1);
    if (blockFacing === "Up" && customSlab.includes(blockAbove.typeId)) {
      if (customSlab.includes(block.typeId)) {
        return;
      }
      else if (blockAbove.typeId === "nicothekid:limestone_brick_slab") {
        if (itemUsed.typeId === "nicothekid:limestone_brick_slab") {
          if (block.typeId === "nicothekid:limestone_brick_slab") return;
          system.run(() => {
            blockAbove.setPermutation(BlockPermutation.resolve("nicothekid:limestone_brick_double_slab"));
            blockAbove.dimension.playSound("use.stone", blockAbove.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockAbove.typeId === "nicothekid:limestone_slab") {
        if (itemUsed.typeId === "nicothekid:limestone_slab") {
          if (block.typeId === "nicothekid:limestone_slab") return;
          system.run(() => {
            blockAbove.setPermutation(BlockPermutation.resolve("nicothekid:limestone_double_slab"));
            blockAbove.dimension.playSound("use.stone", blockAbove.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockAbove.typeId === "nicothekid:marble_brick_slab") {
        if (itemUsed.typeId === "nicothekid:marble_brick_slab") {
          if (block.typeId === "nicothekid:marble_brick_slab") return;
          system.run(() => {
            blockAbove.setPermutation(BlockPermutation.resolve("nicothekid:marble_brick_double_slab"));
            blockAbove.dimension.playSound("place.calcite", blockAbove.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockAbove.typeId === "nicothekid:marble_slab") {
        if (itemUsed.typeId === "nicothekid:marble_slab") {
          if (block.typeId === "nicothekid:marble_slab") return;
          system.run(() => {
            blockAbove.setPermutation(BlockPermutation.resolve("nicothekid:marble_double_slab"));
            blockAbove.dimension.playSound("place.calcite", blockAbove.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockAbove.typeId === "nicothekid:mosshroom_slab") {
        if (itemUsed.typeId === "nicothekid:mosshroom_slab") {
          if (block.typeId === "nicothekid:mosshroom_slab") return;
          system.run(() => {
            blockAbove.setPermutation(BlockPermutation.resolve("nicothekid:mosshroom_double_slab"));
            blockAbove.dimension.playSound("step.nether_wood", blockAbove.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockAbove.typeId === "nicothekid:polished_limestone_slab") {
        if (itemUsed.typeId === "nicothekid:polished_limestone_slab") {
          if (block.typeId === "nicothekid:polished_limestone_slab") return;
          system.run(() => {
            blockAbove.setPermutation(BlockPermutation.resolve("nicothekid:polished_limestone_double_slab"));
            blockAbove.dimension.playSound("use.stone", blockAbove.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockAbove.typeId === "nicothekid:polished_marble_slab") {
        if (itemUsed.typeId === "nicothekid:polished_marble_slab") {
          if (block.typeId === "nicothekid:polished_marble_slab") return;
          system.run(() => {
            blockAbove.setPermutation(BlockPermutation.resolve("nicothekid:polished_marble_double_slab"));
            blockAbove.dimension.playSound("place.calcite", blockAbove.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockAbove.typeId === "nicothekid:polished_soul_stone_slab") {
        if (itemUsed.typeId === "nicothekid:polished_soul_stone_slab") {
          if (block.typeId === "nicothekid:polished_soul_stone_slab") return;
          system.run(() => {
            blockAbove.setPermutation(BlockPermutation.resolve("nicothekid:polished_soul_stone_double_slab"));
            blockAbove.dimension.playSound("use.stone", blockAbove.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockAbove.typeId === "nicothekid:rose_quartz_slab") {
        if (itemUsed.typeId === "nicothekid:rose_quartz_slab") {
          if (block.typeId === "nicothekid:rose_quartz_slab") return;
          system.run(() => {
            blockAbove.setPermutation(BlockPermutation.resolve("nicothekid:rose_quartz_double_slab"));
            blockAbove.dimension.playSound("use.stone", blockAbove.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockAbove.typeId === "nicothekid:smooth_rose_quartz_slab") {
        if (itemUsed.typeId === "nicothekid:smooth_rose_quartz_slab") {
          if (block.typeId === "nicothekid:smooth_rose_quartz_slab") return;
          system.run(() => {
            blockAbove.setPermutation(BlockPermutation.resolve("nicothekid:smooth_rose_quartz_double_slab"));
            blockAbove.dimension.playSound("use.stone", blockAbove.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockAbove.typeId === "nicothekid:soul_stone_brick_slab") {
        if (itemUsed.typeId === "nicothekid:soul_stone_brick_slab") {
          if (block.typeId === "nicothekid:soul_stone_brick_slab") return;
          system.run(() => {
            blockAbove.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_brick_double_slab"));
            blockAbove.dimension.playSound("use.stone", blockAbove.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockAbove.typeId === "nicothekid:soul_stone_slab") {
        if (itemUsed.typeId === "nicothekid:soul_stone_slab") {
          if (block.typeId === "nicothekid:soul_stone_slab") return;
          system.run(() => {
            blockAbove.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_double_slab"));
            blockAbove.dimension.playSound("use.stone", blockAbove.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else return;
    }
    if (blockFacing === "Down" && customSlab.includes(blockBelow.typeId)) {
      if (customSlab.includes(block.typeId)) {
        return;
      }
      else if (blockBelow.typeId === "nicothekid:limestone_brick_slab") {
        if (itemUsed.typeId === "nicothekid:limestone_brick_slab") {
          if (block.typeId === "nicothekid:limestone_brick_slab") return;
          system.run(() => {
            blockBelow.setPermutation(BlockPermutation.resolve("nicothekid:limestone_brick_double_slab"));
            blockBelow.dimension.playSound("use.stone", blockBelow.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockBelow.typeId === "nicothekid:limestone_slab") {
        if (itemUsed.typeId === "nicothekid:limestone_slab") {
          if (block.typeId === "nicothekid:limestone_slab") return;
          system.run(() => {
            blockBelow.setPermutation(BlockPermutation.resolve("nicothekid:limestone_double_slab"));
            blockBelow.dimension.playSound("use.stone", blockBelow.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockBelow.typeId === "nicothekid:marble_brick_slab") {
        if (itemUsed.typeId === "nicothekid:marble_brick_slab") {
          if (block.typeId === "nicothekid:marble_brick_slab") return;
          system.run(() => {
            blockBelow.setPermutation(BlockPermutation.resolve("nicothekid:marble_brick_double_slab"));
            blockBelow.dimension.playSound("place.calcite", blockBelow.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockBelow.typeId === "nicothekid:marble_slab") {
        if (itemUsed.typeId === "nicothekid:marble_slab") {
          if (block.typeId === "nicothekid:marble_slab") return;
          system.run(() => {
            blockBelow.setPermutation(BlockPermutation.resolve("nicothekid:marble_double_slab"));
            blockBelow.dimension.playSound("place.calcite", blockBelow.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockBelow.typeId === "nicothekid:mosshroom_slab") {
        if (itemUsed.typeId === "nicothekid:mosshroom_slab") {
          if (block.typeId === "nicothekid:mosshroom_slab") return;
          system.run(() => {
            blockBelow.setPermutation(BlockPermutation.resolve("nicothekid:mosshroom_double_slab"));
            blockBelow.dimension.playSound("step.nether_wood", blockBelow.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockBelow.typeId === "nicothekid:polished_limestone_slab") {
        if (itemUsed.typeId === "nicothekid:polished_limestone_slab") {
          if (block.typeId === "nicothekid:polished_limestone_slab") return;
          system.run(() => {
            blockBelow.setPermutation(BlockPermutation.resolve("nicothekid:polished_limestone_double_slab"));
            blockBelow.dimension.playSound("use.stone", blockBelow.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockBelow.typeId === "nicothekid:polished_marble_slab") {
        if (itemUsed.typeId === "nicothekid:polished_marble_slab") {
          if (block.typeId === "nicothekid:polished_marble_slab") return;
          system.run(() => {
            blockBelow.setPermutation(BlockPermutation.resolve("nicothekid:polished_marble_double_slab"));
            blockBelow.dimension.playSound("place.calcite", blockBelow.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockBelow.typeId === "nicothekid:polished_soul_stone_slab") {
        if (itemUsed.typeId === "nicothekid:polished_soul_stone_slab") {
          if (block.typeId === "nicothekid:polished_soul_stone_slab") return;
          system.run(() => {
            blockBelow.setPermutation(BlockPermutation.resolve("nicothekid:polished_soul_stone_double_slab"));
            blockBelow.dimension.playSound("use.stone", blockBelow.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockBelow.typeId === "nicothekid:rose_quartz_slab") {
        if (itemUsed.typeId === "nicothekid:rose_quartz_slab") {
          if (block.typeId === "nicothekid:rose_quartz_slab") return;
          system.run(() => {
            blockBelow.setPermutation(BlockPermutation.resolve("nicothekid:rose_quartz_double_slab"));
            blockBelow.dimension.playSound("use.stone", blockBelow.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockBelow.typeId === "nicothekid:smooth_rose_quartz_slab") {
        if (itemUsed.typeId === "nicothekid:smooth_rose_quartz_slab") {
          if (block.typeId === "nicothekid:smooth_rose_quartz_slab") return;
          system.run(() => {
            blockBelow.setPermutation(BlockPermutation.resolve("nicothekid:smooth_rose_quartz_double_slab"));
            blockBelow.dimension.playSound("use.stone", blockBelow.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockBelow.typeId === "nicothekid:soul_stone_brick_slab") {
        if (itemUsed.typeId === "nicothekid:soul_stone_brick_slab") {
          if (block.typeId === "nicothekid:soul_stone_brick_slab") return;
          system.run(() => {
            blockBelow.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_brick_double_slab"));
            blockBelow.dimension.playSound("use.stone", blockBelow.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else if (blockBelow.typeId === "nicothekid:soul_stone_slab") {
        if (itemUsed.typeId === "nicothekid:soul_stone_slab") {
          if (block.typeId === "nicothekid:soul_stone_slab") return;
          system.run(() => {
            blockBelow.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_double_slab"));
            blockBelow.dimension.playSound("use.stone", blockBelow.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      else return;
    }
    if (blockFacing === "South" && customSlab.includes(blockSouth.typeId)) {
      if (blockSouth.typeId === "nicothekid:limestone_brick_slab") {
        if (itemUsed.typeId === "nicothekid:limestone_brick_slab") {
          system.run(() => {
            blockSouth.setPermutation(BlockPermutation.resolve("nicothekid:limestone_brick_double_slab"));
            blockSouth.dimension.playSound("use.stone", blockSouth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockSouth.typeId === "nicothekid:limestone_slab") {
        if (itemUsed.typeId === "nicothekid:limestone_slab") {
          system.run(() => {
            blockSouth.setPermutation(BlockPermutation.resolve("nicothekid:limestone_double_slab"));
            blockSouth.dimension.playSound("use.stone", blockSouth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockSouth.typeId === "nicothekid:marble_brick_slab") {
        if (itemUsed.typeId === "nicothekid:marble_brick_slab") {
          system.run(() => {
            blockSouth.setPermutation(BlockPermutation.resolve("nicothekid:marble_brick_double_slab"));
            blockSouth.dimension.playSound("place.calcite", blockSouth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockSouth.typeId === "nicothekid:marble_slab") {
        if (itemUsed.typeId === "nicothekid:marble_slab") {
          system.run(() => {
            blockSouth.setPermutation(BlockPermutation.resolve("nicothekid:marble_double_slab"));
            blockSouth.dimension.playSound("place.calcite", blockSouth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockSouth.typeId === "nicothekid:mosshroom_slab") {
        if (itemUsed.typeId === "nicothekid:mosshroom_slab") {
          system.run(() => {
            blockSouth.setPermutation(BlockPermutation.resolve("nicothekid:mosshroom_double_slab"));
            blockSouth.dimension.playSound("step.nether_wood", blockSouth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockSouth.typeId === "nicothekid:polished_limestone_slab") {
        if (itemUsed.typeId === "nicothekid:polished_limestone_slab") {
          system.run(() => {
            blockSouth.setPermutation(BlockPermutation.resolve("nicothekid:polished_limestone_double_slab"));
            blockSouth.dimension.playSound("use.stone", blockSouth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockSouth.typeId === "nicothekid:polished_marble_slab") {
        if (itemUsed.typeId === "nicothekid:polished_marble_slab") {
          system.run(() => {
            blockSouth.setPermutation(BlockPermutation.resolve("nicothekid:polished_marble_double_slab"));
            blockSouth.dimension.playSound("place.calcite", blockSouth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockSouth.typeId === "nicothekid:polished_soul_stone_slab") {
        if (itemUsed.typeId === "nicothekid:polished_soul_stone_slab") {
          system.run(() => {
            blockSouth.setPermutation(BlockPermutation.resolve("nicothekid:polished_soul_stone_double_slab"));
            blockSouth.dimension.playSound("use.stone", blockSouth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockSouth.typeId === "nicothekid:rose_quartz_slab") {
        if (itemUsed.typeId === "nicothekid:rose_quartz_slab") {
          system.run(() => {
            blockSouth.setPermutation(BlockPermutation.resolve("nicothekid:rose_quartz_double_slab"));
            blockSouth.dimension.playSound("use.stone", blockSouth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockSouth.typeId === "nicothekid:smooth_rose_quartz_slab") {
        if (itemUsed.typeId === "nicothekid:smooth_rose_quartz_slab") {
          system.run(() => {
            blockSouth.setPermutation(BlockPermutation.resolve("nicothekid:smooth_rose_quartz_double_slab"));
            blockSouth.dimension.playSound("use.stone", blockSouth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockSouth.typeId === "nicothekid:soul_stone_brick_slab") {
        if (itemUsed.typeId === "nicothekid:soul_stone_brick_slab") {
          system.run(() => {
            blockSouth.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_brick_double_slab"));
            blockSouth.dimension.playSound("use.stone", blockSouth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockSouth.typeId === "nicothekid:soul_stone_slab") {
        if (itemUsed.typeId === "nicothekid:soul_stone_slab") {
          system.run(() => {
            blockSouth.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_double_slab"));
            blockSouth.dimension.playSound("use.stone", blockSouth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
    }
    if (blockFacing === "East" && customSlab.includes(blockEast.typeId)) {
      if (blockEast.typeId === "nicothekid:limestone_brick_slab") {
        if (itemUsed.typeId === "nicothekid:limestone_brick_slab") {
          system.run(() => {
            blockEast.setPermutation(BlockPermutation.resolve("nicothekid:limestone_brick_double_slab"));
            blockEast.dimension.playSound("use.stone", blockEast.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockEast.typeId === "nicothekid:limestone_slab") {
        if (itemUsed.typeId === "nicothekid:limestone_slab") {
          system.run(() => {
            blockEast.setPermutation(BlockPermutation.resolve("nicothekid:limestone_double_slab"));
            blockEast.dimension.playSound("use.stone", blockEast.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockEast.typeId === "nicothekid:marble_brick_slab") {
        if (itemUsed.typeId === "nicothekid:marble_brick_slab") {
          system.run(() => {
            blockEast.setPermutation(BlockPermutation.resolve("nicothekid:marble_brick_double_slab"));
            blockEast.dimension.playSound("place.calcite", blockEast.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockEast.typeId === "nicothekid:marble_slab") {
        if (itemUsed.typeId === "nicothekid:marble_slab") {
          system.run(() => {
            blockEast.setPermutation(BlockPermutation.resolve("nicothekid:marble_double_slab"));
            blockEast.dimension.playSound("place.calcite", blockEast.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockEast.typeId === "nicothekid:mosshroom_slab") {
        if (itemUsed.typeId === "nicothekid:mosshroom_slab") {
          system.run(() => {
            blockEast.setPermutation(BlockPermutation.resolve("nicothekid:mosshroom_double_slab"));
            blockEast.dimension.playSound("step.nether_wood", blockEast.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockEast.typeId === "nicothekid:polished_limestone_slab") {
        if (itemUsed.typeId === "nicothekid:polished_limestone_slab") {
          system.run(() => {
            blockEast.setPermutation(BlockPermutation.resolve("nicothekid:polished_limestone_double_slab"));
            blockEast.dimension.playSound("use.stone", blockEast.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockEast.typeId === "nicothekid:polished_marble_slab") {
        if (itemUsed.typeId === "nicothekid:polished_marble_slab") {
          system.run(() => {
            blockEast.setPermutation(BlockPermutation.resolve("nicothekid:polished_marble_double_slab"));
            blockEast.dimension.playSound("place.calcite", blockEast.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockEast.typeId === "nicothekid:polished_soul_stone_slab") {
        if (itemUsed.typeId === "nicothekid:polished_soul_stone_slab") {
          system.run(() => {
            blockEast.setPermutation(BlockPermutation.resolve("nicothekid:polished_soul_stone_double_slab"));
            blockEast.dimension.playSound("use.stone", blockEast.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockEast.typeId === "nicothekid:rose_quartz_slab") {
        if (itemUsed.typeId === "nicothekid:rose_quartz_slab") {
          system.run(() => {
            blockEast.setPermutation(BlockPermutation.resolve("nicothekid:rose_quartz_double_slab"));
            blockEast.dimension.playSound("use.stone", blockEast.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockEast.typeId === "nicothekid:smooth_rose_quartz_slab") {
        if (itemUsed.typeId === "nicothekid:smooth_rose_quartz_slab") {
          system.run(() => {
            blockEast.setPermutation(BlockPermutation.resolve("nicothekid:smooth_rose_quartz_double_slab"));
            blockEast.dimension.playSound("use.stone", blockEast.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockEast.typeId === "nicothekid:soul_stone_brick_slab") {
        if (itemUsed.typeId === "nicothekid:soul_stone_brick_slab") {
          system.run(() => {
            blockEast.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_brick_double_slab"));
            blockEast.dimension.playSound("use.stone", blockEast.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockEast.typeId === "nicothekid:soul_stone_slab") {
        if (itemUsed.typeId === "nicothekid:soul_stone_slab") {
          system.run(() => {
            blockEast.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_double_slab"));
            blockEast.dimension.playSound("use.stone", blockEast.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
    }
    if (blockFacing === "North" && customSlab.includes(blockNorth.typeId)) {
      if (blockNorth.typeId === "nicothekid:limestone_brick_slab") {
        if (itemUsed.typeId === "nicothekid:limestone_brick_slab") {
          system.run(() => {
            blockNorth.setPermutation(BlockPermutation.resolve("nicothekid:limestone_brick_double_slab"));
            blockNorth.dimension.playSound("use.stone", blockNorth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockNorth.typeId === "nicothekid:limestone_slab") {
        if (itemUsed.typeId === "nicothekid:limestone_slab") {
          system.run(() => {
            blockNorth.setPermutation(BlockPermutation.resolve("nicothekid:limestone_double_slab"));
            blockNorth.dimension.playSound("use.stone", blockNorth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockNorth.typeId === "nicothekid:marble_brick_slab") {
        if (itemUsed.typeId === "nicothekid:marble_brick_slab") {
          system.run(() => {
            blockNorth.setPermutation(BlockPermutation.resolve("nicothekid:marble_brick_double_slab"));
            blockNorth.dimension.playSound("place.calcite", blockNorth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockNorth.typeId === "nicothekid:marble_slab") {
        if (itemUsed.typeId === "nicothekid:marble_slab") {
          system.run(() => {
            blockNorth.setPermutation(BlockPermutation.resolve("nicothekid:marble_double_slab"));
            blockNorth.dimension.playSound("place.calcite", blockNorth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockNorth.typeId === "nicothekid:mosshroom_slab") {
        if (itemUsed.typeId === "nicothekid:mosshroom_slab") {
          system.run(() => {
            blockNorth.setPermutation(BlockPermutation.resolve("nicothekid:mosshroom_double_slab"));
            blockNorth.dimension.playSound("step.nether_wood", blockNorth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockNorth.typeId === "nicothekid:polished_limestone_slab") {
        if (itemUsed.typeId === "nicothekid:polished_limestone_slab") {
          system.run(() => {
            blockNorth.setPermutation(BlockPermutation.resolve("nicothekid:polished_limestone_double_slab"));
            blockNorth.dimension.playSound("use.stone", blockNorth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockNorth.typeId === "nicothekid:polished_marble_slab") {
        if (itemUsed.typeId === "nicothekid:polished_marble_slab") {
          system.run(() => {
            blockNorth.setPermutation(BlockPermutation.resolve("nicothekid:polished_marble_double_slab"));
            blockNorth.dimension.playSound("place.calcite", blockNorth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockNorth.typeId === "nicothekid:polished_soul_stone_slab") {
        if (itemUsed.typeId === "nicothekid:polished_soul_stone_slab") {
          system.run(() => {
            blockNorth.setPermutation(BlockPermutation.resolve("nicothekid:polished_soul_stone_double_slab"));
            blockNorth.dimension.playSound("use.stone", blockNorth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockNorth.typeId === "nicothekid:rose_quartz_slab") {
        if (itemUsed.typeId === "nicothekid:rose_quartz_slab") {
          system.run(() => {
            blockNorth.setPermutation(BlockPermutation.resolve("nicothekid:rose_quartz_double_slab"));
            blockNorth.dimension.playSound("use.stone", blockNorth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockNorth.typeId === "nicothekid:smooth_rose_quartz_slab") {
        if (itemUsed.typeId === "nicothekid:smooth_rose_quartz_slab") {
          system.run(() => {
            blockNorth.setPermutation(BlockPermutation.resolve("nicothekid:smooth_rose_quartz_double_slab"));
            blockNorth.dimension.playSound("use.stone", blockNorth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockNorth.typeId === "nicothekid:soul_stone_brick_slab") {
        if (itemUsed.typeId === "nicothekid:soul_stone_brick_slab") {
          system.run(() => {
            blockNorth.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_brick_double_slab"));
            blockNorth.dimension.playSound("use.stone", blockNorth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockNorth.typeId === "nicothekid:soul_stone_slab") {
        if (itemUsed.typeId === "nicothekid:soul_stone_slab") {
          system.run(() => {
            blockNorth.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_double_slab"));
            blockNorth.dimension.playSound("use.stone", blockNorth.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
    }
    if (blockFacing === "West" && customSlab.includes(blockWest.typeId)) {
      if (blockWest.typeId === "nicothekid:limestone_brick_slab") {
        if (itemUsed.typeId === "nicothekid:limestone_brick_slab") {
          system.run(() => {
            blockWest.setPermutation(BlockPermutation.resolve("nicothekid:limestone_brick_double_slab"));
            blockWest.dimension.playSound("use.stone", blockWest.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockWest.typeId === "nicothekid:limestone_slab") {
        if (itemUsed.typeId === "nicothekid:limestone_slab") {
          system.run(() => {
            blockWest.setPermutation(BlockPermutation.resolve("nicothekid:limestone_double_slab"));
            blockWest.dimension.playSound("use.stone", blockWest.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockWest.typeId === "nicothekid:marble_brick_slab") {
        if (itemUsed.typeId === "nicothekid:marble_brick_slab") {
          system.run(() => {
            blockWest.setPermutation(BlockPermutation.resolve("nicothekid:marble_brick_double_slab"));
            blockWest.dimension.playSound("place.calcite", blockWest.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockWest.typeId === "nicothekid:marble_slab") {
        if (itemUsed.typeId === "nicothekid:marble_slab") {
          system.run(() => {
            blockWest.setPermutation(BlockPermutation.resolve("nicothekid:marble_double_slab"));
            blockWest.dimension.playSound("place.calcite", blockWest.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockWest.typeId === "nicothekid:mosshroom_slab") {
        if (itemUsed.typeId === "nicothekid:mosshroom_slab") {
          system.run(() => {
            blockWest.setPermutation(BlockPermutation.resolve("nicothekid:mosshroom_double_slab"));
            blockWest.dimension.playSound("step.nether_wood", blockWest.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockWest.typeId === "nicothekid:polished_limestone_slab") {
        if (itemUsed.typeId === "nicothekid:polished_limestone_slab") {
          system.run(() => {
            blockWest.setPermutation(BlockPermutation.resolve("nicothekid:polished_limestone_double_slab"));
            blockWest.dimension.playSound("use.stone", blockWest.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockWest.typeId === "nicothekid:polished_marble_slab") {
        if (itemUsed.typeId === "nicothekid:polished_marble_slab") {
          system.run(() => {
            blockWest.setPermutation(BlockPermutation.resolve("nicothekid:polished_marble_double_slab"));
            blockWest.dimension.playSound("place.calcite", blockWest.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockWest.typeId === "nicothekid:polished_soul_stone_slab") {
        if (itemUsed.typeId === "nicothekid:polished_soul_stone_slab") {
          system.run(() => {
            blockWest.setPermutation(BlockPermutation.resolve("nicothekid:polished_soul_stone_double_slab"));
            blockWest.dimension.playSound("use.stone", blockWest.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockWest.typeId === "nicothekid:rose_quartz_slab") {
        if (itemUsed.typeId === "nicothekid:rose_quartz_slab") {
          system.run(() => {
            blockWest.setPermutation(BlockPermutation.resolve("nicothekid:rose_quartz_double_slab"));
            blockWest.dimension.playSound("use.stone", blockWest.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockWest.typeId === "nicothekid:smooth_rose_quartz_slab") {
        if (itemUsed.typeId === "nicothekid:smooth_rose_quartz_slab") {
          system.run(() => {
            blockWest.setPermutation(BlockPermutation.resolve("nicothekid:smooth_rose_quartz_double_slab"));
            blockWest.dimension.playSound("use.stone", blockWest.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockWest.typeId === "nicothekid:soul_stone_brick_slab") {
        if (itemUsed.typeId === "nicothekid:soul_stone_brick_slab") {
          system.run(() => {
            blockWest.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_brick_double_slab"));
            blockWest.dimension.playSound("use.stone", blockWest.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
      if (blockWest.typeId === "nicothekid:soul_stone_slab") {
        if (itemUsed.typeId === "nicothekid:soul_stone_slab") {
          system.run(() => {
            blockWest.setPermutation(BlockPermutation.resolve("nicothekid:soul_stone_double_slab"));
            blockWest.dimension.playSound("use.stone", blockWest.location, { pitch: 0.8, volume: 1.0 });
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            return;
          });
        }
        else return;
      }
    }
  }
  else return;
});
