import { world, BlockPermutation, ItemStack, GameMode } from "@minecraft/server";
import { dropsOnDestroy } from "../../ntk_functions.js";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:fossiliferous_deepslate_on_player_destroy", {
    onPlayerDestroy: eventData => {
      const player = eventData.player;
      const destroyedBlock = eventData.destroyedBlockPermutation;
      const block = eventData.block;
      const blockLocation = block.location;
      const playerEquippable = player.getComponent("equippable");
      const itemUsed = playerEquippable.getEquipment("Mainhand");
      
      if (itemUsed === undefined || player.matches({ gameMode: GameMode.creative })) return;
      
      if (destroyedBlock.type.id === "nicothekid:fossiliferous_deepslate") {
        if (itemUsed.hasTag("minecraft:is_pickaxe")) {
          dropsOnDestroy(player, block, itemUsed, "minecraft:bone", 1, true);
        }
        else return;
      }
      else return;
    }
  });
})
