import { world, system, BlockPermutation, GameMode } from "@minecraft/server";
import { potableItems } from "../../ntk_listing.js";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:nce_potted_plants_on_player_interact", {
    onPlayerInteract: eventData => {
      const player = eventData.player;
      const block = eventData.block;
      const blockLocation = block.location;
      const playerEquippable = player.getComponent("equippable");
      const itemUsed = playerEquippable.getEquipment("Mainhand");
      
      if (itemUsed === undefined || !potableItems.includes(itemUsed.typeId)) {
        if (block.permutation.matches("nicothekid:potted_mosshroom_fungus")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:mosshroom_fungus 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_glowcelium_sprouts")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:tall_glowcelium_sprouts 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_mycelium_sprouts")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:tall_mycelium_sprouts 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
      }
      else return;
    }
  });
});
world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:potted_glowcelium_sprouts_particles_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      if (block.typeId === "nicothekid:potted_glowcelium_sprouts") {
        block.dimension.spawnParticle("nicothekid:glowcelium_sprouts_particle", { x: blockLocation.x + 0.5, y: blockLocation.y + 0.7, z: blockLocation.z + 0.5 });
        return;
      }
      else return;
    }
  });
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:potted_mycelium_sprouts_particles_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      if (block.typeId === "nicothekid:potted_mycelium_sprouts") {
        block.dimension.spawnParticle("nicothekid:mycelium_sprouts_particle", { x: blockLocation.x + 0.5, y: blockLocation.y + 0.7, z: blockLocation.z + 0.5 });
        return;
      }
      else return;
    }
  });
});
