import { world, system, BlockPermutation, GameMode } from "@minecraft/server";
import { instantDiggableBlocks } from "../ntk_listing.js";
import { damageItemDurability } from "../ntk_functions.js";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent("nicothekid:custom_tools_nce_on_mine_block", {
    onMineBlock: eventData => {
      const player = eventData.source;
      const itemUsed = eventData.itemStack;
      const block = eventData.block;
      const blockPermutation = eventData.minedBlockPermutation;
      const playerEquippable = player.getComponent("equippable");
      
      if (itemUsed.hasTag("minecraft:is_axe") || itemUsed.hasTag("minecraft:is_hoe") || itemUsed.hasTag("minecraft:is_pickaxe") || itemUsed.hasTag("minecraft:is_shovel")) {
        if (!instantDiggableBlocks.includes(blockPermutation.type.id) && !blockPermutation.hasTag("nicothekid:instant_diggable")) {
          damageItemDurability(player, itemUsed, 1, "Mainhand");
        }
        else return;
      }
      else return;
    }
  });
});
