import { world, system, BlockPermutation, Dimension, ItemStack, GameMode } from "@minecraft/server";
import { decreaseItemStack } from "../../ntk_functions.js";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent("nicothekid:mosshroom_fungus_on_use_on", {
    onUseOn: eventData => {
      const player = eventData.source;
      const itemUsed = eventData.itemStack;
      const block = eventData.block;
      const playerEquippable = player.getComponent("equippable");
      
      if (player.isSneaking) return;
      if (itemUsed.typeId === "nicothekid:mosshroom_fungus") {
        system.run(() => {
          if (block.typeId === "minecraft:flower_pot") {
            decreaseItemStack(player, itemUsed, 1, "Mainhand");
            block.setPermutation(BlockPermutation.resolve("nicothekid:potted_mosshroom_fungus"));
          }
        });
      }
    }
  });
});